PLDAPSchema Class Reference

`#include <pldap.h>`

Inheritance diagram for PLDAPSchema:

## Classes

class | Attribute

## Public Types

enum | AttributeType { AttibuteUnknown = -1, AttributeString, AttributeBinary, AttributeNumeric }
typedef std::list< Attribute > | attributeList
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| PLDAPSchema ()
void | OnReceivedAttribute (const PString &attribute, const PString &value)
void | OnSendSchema (PArray< PLDAPSession::ModAttrib > &attributes, PLDAPSession::ModAttrib::Operation op=PLDAPSession::ModAttrib::Add)
void | LoadSchema ()
PStringList | SchemaName ()
virtual void | AttributeList (attributeList &)
PStringList | GetAttributeList ()
PBoolean | Exists (const PString &attribute)
PBoolean | SetAttribute (const PString &attribute, const PString &value)
PBoolean | SetAttribute (const PString &attribute, const PBYTEArray &value)
PBoolean | GetAttribute (const PString &attribute, PString &value)
PBoolean | GetAttribute (const PString &attribute, PBYTEArray &value)
AttributeType | GetAttributeType (const PString &attribute)
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

static PLDAPSchema * | CreateSchema (const PString &schemaname, PPluginManager *pluginMgr=NULL)
static PStringList | GetSchemaNames (PPluginManager *pluginMgr=NULL)
static PStringList | GetSchemaFriendlyNames (const PString &schema, PPluginManager *pluginMgr=NULL)
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...

## Protected Types

typedef std::map< PString, PString > | ldapAttributes
typedef std::map< PString, PBYTEArray > | ldapBinAttributes

## Protected Attributes

attributeList | attributelist
ldapAttributes | attributes
ldapBinAttributes | binattributes

## Additional Inherited Members

Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Member Typedef Documentation

typedef std::list<Attribute> PLDAPSchema::attributeList

typedef std::map<PString,PString> PLDAPSchema::ldapAttributes

protected

typedef std::map<PString,PBYTEArray> PLDAPSchema::ldapBinAttributes

protected

## Member Enumeration Documentation

enum PLDAPSchema::AttributeType

Enumerator
AttibuteUnknown |
AttributeString |
AttributeBinary |
AttributeNumeric |

## Constructor & Destructor Documentation

PLDAPSchema::PLDAPSchema | ( |  | ) |

## Member Function Documentation

virtual void PLDAPSchema::AttributeList | ( | attributeList & |  | ) |

inline virtual

static PLDAPSchema* PLDAPSchema::CreateSchema | ( | const PString & | schemaname,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

static

PBoolean PLDAPSchema::Exists | ( | const PString & | attribute | ) |

PBoolean PLDAPSchema::GetAttribute | ( | const PString & | attribute,
|  | PString & | value
| ) |  |

PBoolean PLDAPSchema::GetAttribute | ( | const PString & | attribute,
|  | PBYTEArray & | value
| ) |  |

PStringList PLDAPSchema::GetAttributeList | ( |  | ) |

AttributeType PLDAPSchema::GetAttributeType | ( | const PString & | attribute | ) |

static PStringList PLDAPSchema::GetSchemaFriendlyNames | ( | const PString & | schema,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

static

static PStringList PLDAPSchema::GetSchemaNames | ( | PPluginManager * | pluginMgr = `NULL` | ) |

static

void PLDAPSchema::LoadSchema | ( |  | ) |

void PLDAPSchema::OnReceivedAttribute | ( | const PString & | attribute,
|  | const PString & | value
| ) |  |

void PLDAPSchema::OnSendSchema | ( | PArray< PLDAPSession::ModAttrib > & | attributes,
|  | PLDAPSession::ModAttrib::Operation | op = `PLDAPSession::ModAttrib::Add`
| ) |  |

PStringList PLDAPSchema::SchemaName | ( |  | ) |

inline

PBoolean PLDAPSchema::SetAttribute | ( | const PString & | attribute,
|  | const PString & | value
| ) |  |

PBoolean PLDAPSchema::SetAttribute | ( | const PString & | attribute,
|  | const PBYTEArray & | value
| ) |  |

## Member Data Documentation

attributeList PLDAPSchema::attributelist

protected

ldapAttributes PLDAPSchema::attributes

protected

ldapBinAttributes PLDAPSchema::binattributes

protected

The documentation for this class was generated from the following file:

- pldap.h